#include "AI_Behaviors.h"
#include "AIMonster.h"
#include <Windows.h>



	AI_Behaviors::AI_Behaviors()
	{
		walk   = false;
		attack = false;
		idle   = false;
		flee   = false;
		seek   = false;
		wander = false;
	}//end of constructor


	bool AI_Behaviors::WanderON(){return wander = true;}
	bool AI_Behaviors::WanderOFF(){return wander = false;}
	bool AI_Behaviors::SeekON(){return seek = true;}
	bool AI_Behaviors::SeekOFF(){return seek = false;}
	bool AI_Behaviors::AttackON(){return attack = true;}
	bool AI_Behaviors::AttackOFF(){return attack = false;}
	bool AI_Behaviors::FleeON(){return flee = true;}
	bool AI_Behaviors::FleeOFF(){return flee = false;}

//Calulate the damage the mob does depending on level difference, crit chance
//, equipment and defence rating
	void AI_Behaviors::Calulate_Attack(AIMonster *monster, Creature *player, Ogre::FrameEvent &evt)
	{
		int levelDifference = player->level - monster->level;

		int monster_HitChance = rand()%levelDifference+1;
		int monster_Damage = monster->level *monster->realAttackStt *monster->DEXTLEVELUP /player->realDefenceStt;
		long TimePassed = GetTickCount();

		if(TimePassed >= 1000)
		{
			if(monster_HitChance == 1)
			{
				player->realHealthStt - monster_Damage;
			}//end of if
		}//end of if

	}//end of Calulate_Attack()



	//Seeks the position 
	void AI_Behaviors::Seek(AIMonster *monster)
	{
		if(seek == true)
		{
			monster->mDirection = monster->mDestination - monster->entityNode->getPosition();
			monster->mDistance  = monster->mDirection.normalise();
			Ogre::LogManager::getSingleton().logMessage("\n seek works \n");
		}//end of if
	}//end of Seek



	void AI_Behaviors::Flee(AIMonster *monster)
	{
		if(flee == true)
		{
			monster->mDirection = monster->entityNode->getPosition()  - monster->mDestination;
			monster->mDistance  = monster->mDirection.normalise();
		}//end of flee
	}//end of seek()	


	void AI_Behaviors::RandomDestination(AIMonster *monster)
	{
		monster->mDestination = Ogre::Vector3(Ogre::Math::RangeRandom(-100,100),
			-monster->box.getCorner(Ogre::AxisAlignedBox::FAR_LEFT_BOTTOM).y*monster->scale,
			Ogre::Math::RangeRandom(-100,100));
	}//end of if RandomDestination()


	void AI_Behaviors::Wander(AIMonster *monster)
	{
		if(wander == true)
		{
			Seek(monster);
			if(monster->mDistance <= 0.0f)
				wander = false;
		}//end of if
	}//end of Wander


	//void AI_Behaviors::Wander(AIMonster *monster, const Ogre::FrameEvent& evt)
	//{
	//	double time = rand()%1+5 * evt.timeSinceLastFrame;
	//	if(time >= 1)	
	//	{
	//		Animation(evt,"Idle");
	//		time--;
	//	}//end of if
	//	Ogre::Vector3 newLocation;
	//	newLocation.y = -box.getCorner(Ogre::AxisAlignedBox::FAR_LEFT_BOTTOM).y*scale;
	//	
	//	bool ACTIVE = true;

	//		if(ACTIVE)
	//		{
	//			newLocation.x = rand()%1+100;
	//			newLocation.z = rand()%1+100;

	//			ACTIVE = false;
	//		}//end of if
	//		else
	//		{
	//			//Seek(newLocation);
	//			Animation(evt,"Walk");

	//			if(mDistance <= 0.1f)
	//			{
	//				mDirection = Ogre::Vector3::ZERO;
	//				entityNode->setPosition(newLocation);
	//				Animation(evt,"Idle");
	//				ACTIVE = true;
	//			}//end of if
	//		}//end of else
	//}//end of wander