#include <stdlib.h>     /* srand, rand */
#include <time.h>       /* time */
#include <OgreRoot.h>

#pragma once

class AIMonster;
class Creature;

class AI_Behaviors
{
public:
	bool walk;
	bool idle;
	bool attack;
	bool seek;
	bool flee;
	bool wander;
	double attackRadius;

//*****************************************************************************
	//Constructors, destructors
//*****************************************************************************
	AI_Behaviors();

//Calulate the damage the mob does depending on level difference, crit chance
//, equipment and defence rating
	void Calulate_Attack(AIMonster *monster, Creature *player, Ogre::FrameEvent &evt);

	//Seeks the position 
	void Seek(AIMonster *monster);

	//flee from position
	void Flee(AIMonster *monster);

	//wander randomly
	void Wander(AIMonster *monster);

	void RandomDestination(AIMonster *monster);

//*****************************************************************************

	bool WanderON();
	bool WanderOFF();
	bool SeekON();
	bool SeekOFF();
	bool AttackON();
	bool AttackOFF();
	bool FleeON();
	bool FleeOFF();
};//end of class