//Filename: BuildMap.h //
#include <OgreRoot.h>
#include "Object.h"


class BuildMap : public Object
{
public:
	int i;
	//Ogre::Entity* mapEnt;         // The Entity we are animating
 //   Ogre::SceneNode* mapNode;  // The SceneNode that the Entity is attached to
	//Ogre::SceneManager* mapSceneMgr;
	

	BuildMap();
	~BuildMap();

	void createMainFloorPlane(Ogre::SceneManager* sentSceneMgr);

	void createTunnelPlane(Ogre::SceneManager* sentSceneMgr, Ogre::String planeName, 
		Ogre::Radian angle, Ogre::Real xPos, Ogre::Real yPos, Ogre::Real zPos);

	void createCavernPlane(Ogre::SceneManager* sentSceneMgr, Ogre::String planeName, 
		Ogre::Vector3 axis, Ogre::Radian angle,
		Ogre::Real xPos, Ogre::Real yPos, Ogre::Real zPos);

	void createCavernDoorPlaneLeft(Ogre::SceneManager* sentSceneMgr, Ogre::String planeName, 
		Ogre::Vector3 axis, Ogre::Radian angle, 
		Ogre::Real xPos, Ogre::Real yPos, Ogre::Real zPos);

	void createCavernDoorPlaneMiddle(Ogre::SceneManager* sentSceneMgr, Ogre::String planeName, 
		Ogre::Vector3 axis, Ogre::Radian angle, 
		Ogre::Real xPos, Ogre::Real yPos, Ogre::Real zPos);

	void createCavernDoorPlaneRight(Ogre::SceneManager* sentSceneMgr, Ogre::String planeName, 
		Ogre::Vector3 axis, Ogre::Radian angle, 
		Ogre::Real xPos, Ogre::Real yPos, Ogre::Real zPos);

	void create(Ogre::SceneManager* sentSceneMgr, Ogre::String theName);

    void reset();

    void addGravity(const Ogre::FrameEvent& evt);
};