#include "Flee_State.h"	
#include "Wander.h"


Flee_State *Flee_State::instance = NULL; // to prevent more than one instance
Flee_State::Flee_State(){};


Flee_State *Flee_State::Get_instance()
{
	if(instance == NULL)
		instance = new Flee_State;
	return instance;
}//end of Flee_State constructer



void Flee_State::Enter_State(AIMonster *Monster)
{
	Ogre::LogManager::getSingleton().logMessage("\n enter wander state \n");
	Monster->AIB->WanderOFF();
	Monster->AIB->SeekOFF();
	Monster->AIB->AttackOFF();
	Monster->AIB->FleeON();

	Monster->attackAN = false;
	Monster->idleAN	  = false;
	Monster->walkAN   = true;

	//Monster->AIB->RandomDestination(Monster);
}//end of Enter_State()


void Flee_State::Execute_State(AIMonster *Monster)
{
	Monster->AIB->Flee(Monster);
	Ogre::LogManager::getSingleton().logMessage("\n wander execute state\n");
}//end of Execute_State()


void Flee_State::Exit_State(AIMonster *Monster)
{
	Ogre::Vector3 direction = Monster->Player_Location - Monster->entityNode->getPosition();
	Ogre::Real distance	= direction.normalise();

	if(distance >= 200)
	{
		Change_State(Wander::Get_instance(),Monster);
	}//end of if

}//end of exit_State()

