
#include "Item.h"
#pragma once

class Player;

class Inventory
{
private:
	static const int MAXIMUMNUMBEROFITEM = 50;
	Object* itemInInventory[MAXIMUMNUMBEROFITEM];
	int numberOfItems;
public:
	Inventory();

	bool equipWeapon(Object* item, Player* player);

	bool equipArmour(Object* item, Player* player);

	bool useItem(Object* item, Player* player);

	bool addItemToInventory(Object* item, Player* player);

	bool isInventoryFull(Player* player);
};//end Inventory