#include "Object.h"
#pragma once

//Types of item available. All items will have a type
enum ItemTypes {NONE, BOW, SLINGSHOT, SPEAR, CLUB, HELMET, 
								CUIRASS, GREAVES, BOOTS, POTION,
								ACCESSORIES, THROWABLE};

class Item: public Object
{
private:

	int weightStt;
	bool equippable;
	bool isOnEnvironment;
	ItemTypes type;
public:
	Item();

	Item(string sentName, 
			 int sentWeightStt, 
			 bool sentEquippable, 
			 bool sentIsOnEnvironment,
			 ItemTypes sentType);

  ~Item();

	void setIsOnEnvironment(bool value);

	int getWeightStt();

	bool getEquippable();

	bool getIsOnEnvironment();

	ItemTypes getType();

	string getName();



};//end Item