#include "Creature.h"

#pragma once

enum MonsterTypes {SNOTTLING, BAT, WOLF, UNKNOWN};

class Monster: public Creature
{
private:
	
	MonsterTypes monsterType;
public:

	Monster();
	Monster(MonsterTypes type, int requestedLevel);
	~Monster();

	void create(Ogre::SceneManager* sentSceneMgr, Ogre::String theName);

	void update();

	MonsterTypes getMonsterType();

	void updateRealStats();

	void reset();


};