// Title        : SpriteAnimation.h
// Date         : 21/05/13
// Description : Seperate animation processing from code bulk

#pragma once

class Sprite_Animation
{
private:

protected:
  Ogre::AnimationState *mAnimationState;  //animation state

public:
  Sprite_Animation()
  {
  }//end of constructor

  ~Sprite_Animation()
  {
  }//end of destructor

  void Set_Animation(const Ogre::FrameEvent &evt, string aNAME, Ogre::Entity entity)
  {
    // Set idle animation
    mAnimationState = entity.getAnimationState(aNAME);
    mAnimationState->setLoop(true);
    mAnimationState->setEnabled(true);

	mAnimationState->addTime(evt.timeSinceLastFrame);
  }//end of idle()


  void EndAnimation()
  {
    mAnimationState->setLoop(false);
    mAnimationState->setEnabled(false);
  }//end of EndAnimation()

};//end of class
