#include "Wander.h"	
#include <stdlib.h>     /* srand, rand */
#include <time.h>       /* time */
#include "Pursue_State.h"
#include "Flee_State.h"


Wander *Wander::instance = NULL; // to prevent more than one instance
Wander::Wander(){};


Wander *Wander::Get_instance()
{
	if(instance == NULL)
		instance = new Wander;
	return instance;
}//end of Flee_State constructer



void Wander::Enter_State(AIMonster *Monster)
{
	Ogre::LogManager::getSingleton().logMessage("\n enter wander state \n");
	Monster->AIB->WanderON();
	Monster->AIB->SeekOFF();
	Monster->AIB->AttackOFF();
	Monster->AIB->FleeOFF();

	Monster->attackAN = false;
	Monster->idleAN	  = true;
	Monster->walkAN   = false;

	//Monster->AIB->RandomDestination(Monster);
}//end of Enter_State()


void Wander::Execute_State(AIMonster *Monster)
{

	Ogre::LogManager::getSingleton().logMessage("\n wander execute state\n");
}//end of Execute_State()


void Wander::Exit_State(AIMonster *Monster)
{
	Ogre::Vector3 direction = Monster->Player_Location - Monster->entityNode->getPosition();
	Ogre::Real distance	= direction.normalise();

	if((distance >= Monster->length/1.5)&&(distance < 1000))
	{
		Change_State(Pursue_State::Get_instance(),Monster);
	}//end of if

	if(Monster->STARTINGHEALTH <= 10)
	{
		Change_State(Flee_State::Get_instance(),Monster);
	}//end of if

}//end of exit_State()

