// Title       : Armour.cpp
// Date        : 21/05/13
// Description : The implementation of the class for the player's armour

#include "Armour.h"

// ****************************************************************************
// Constructors and Destructors
  
 Armour::Armour()
{ // Constructor

  // Initialise variables
  armourType = ArmourTypeNone;
  defenceStt = 0;
  this->objectType = ObjectArmourType;
}

// ****************************************************************************
// Getters and Setters

void Armour::setArmourType(ArmourType value)
{ // Sets the armour type
  armourType = value;
}

ArmourType Armour::getArmourType()
{ // Gets the armour type
  return armourType;
}

void Armour::setDenfenceStt(int value)
{ // Sets the defence stat of the armour
  defenceStt = value;
}

int Armour::getDefenceStt()
{ // Gets the defence stat of the armour
  return defenceStt;
}

// ****************************************************************************