#include "Attack_State.h"	
#include "Pursue_State.h"
#include "Flee_State.h"


Attack_State *Attack_State::instance = NULL; // to prevent more than one instance
Attack_State::Attack_State(){};


Attack_State *Attack_State::Get_instance()
{
	if(instance == NULL)
		instance = new Attack_State;
	return instance;
}//end of Flee_State constructer



void Attack_State::Enter_State(AIMonster *Monster)
{
	Monster->AIB->WanderOFF();
	Monster->AIB->AttackON();
	Monster->AIB->FleeOFF();
	Monster->AIB->SeekOFF();
	Monster->attackAN = true;
	Monster->idleAN	  = false;
	Monster->walkAN   = false;
}//end of Enter_State()


void Attack_State::Execute_State(AIMonster *Monster)
{
	//Monster->AIB->Calulate_Attack(Monster,
	Ogre::LogManager::getSingleton().logMessage("\n attack execute state\n");
}//end of Execute_State()


void Attack_State::Exit_State(AIMonster *Monster)
{
	Ogre::Vector3 direction = Monster->Player_Location - Monster->entityNode->getPosition();
	Ogre::Real distance	= direction.normalise();
	
	if(distance > Monster->length*1.5)
	{
		Change_State(Pursue_State::Get_instance(), Monster);
	}//end of if

	if(Monster->STARTINGHEALTH <= 10)
	{
		Change_State(Flee_State::Get_instance(),Monster);
	}//end of if
}//end of exit_State()

