#include "Item.h"

//standard constructor
Item::Item()
{
	name = "Unkown";
	equippable = false;
	isOnEnvironment = false;
	weightStt = 1;
	type = NONE;
}//end standard constructor

//overidden constructor
Item::Item(string sentName, 
			int sentWeightStt, 
			bool sentEquippable, 
			bool sentIsOnEnvironment,
			ItemTypes sentType)
{
	name = sentName;
	equippable = sentEquippable;
	isOnEnvironment = sentIsOnEnvironment;
	weightStt = sentWeightStt;
	type = sentType;
}//end overidden constructor

//destructor
Item::~Item()
{
}
//end destructor

//check to see if item is in environment
void Item::setIsOnEnvironment(bool value)
{
	isOnEnvironment = value;
}//end isOnEnvironment

//get the weight stat
int Item::getWeightStt()
{
	return weightStt;
}//end getWeightStt

//check to see if item is equippable????
bool Item::getEquippable()
{
	return equippable;
}//end getEquippable

//check to see if item is in environment
bool Item::getIsOnEnvironment()
{
	return isOnEnvironment;
}// end getIsOnEnvironment

//get tpe of item
ItemTypes Item::getType()
{
	return type;
}//end getType

//get the name of the item
string Item::getName()
{
	return name;
}//end getName