#include "Monster.h"

//class constructor
Monster::Monster()
{
  active = true;
	
  // set the rotation and move speed
  rotateValue = 0.13;
  moveValue = 250;

  alive = true;

  name = "Unkown";
  scale = 10.0;

//		direction = (Ogre::Math::PI/2);
		
}// end constructor


//class destructor
Monster::~Monster()
{
  if(raySceneQuery)
    sceneMgr->destroyQuery(raySceneQuery);
}//end destructor


//create a new monster
void Monster::create(Ogre::SceneManager* sentSceneMgr, Ogre::String theName)
{
  sceneMgr = sentSceneMgr; // get a copy of sceneManager.

  name = theName;
			
  // Create the entity
  entity = sceneMgr->createEntity(name, "Date Model Armed.mesh");
  meshBox = entity->getBoundingBox();
		
 
  entityNode = sentSceneMgr->getRootSceneNode()->createChildSceneNode();
  entityNode->attachObject(entity); // attach player's entity to player node.
		

  entityNode->setScale(scale,scale,scale); // make player's mesh smaller.
  entityNode->setPosition(0,-meshBox.getCorner(Ogre::AxisAlignedBox::FAR_LEFT_BOTTOM).y*scale,-400); // set position of player node.
  length = meshBox.getSize().x;

  // stores starting x direction of player's mesh
  //direction = entityNode->getOrientation() * Ogre::Vector3::UNIT_X;



  entityNode->showBoundingBox(true);
  raySceneQuery = sceneMgr->createRayQuery(Ogre::Ray());
}

void Monster::update()
{
//	Ogre::Vector3 direction = Ogre::Vector3(Ogre::Math::Cos(mMechDirection),0,Ogre::Math::Sin(mMechDirection));
//  Ogre::Vector3 position = mMechNode->getPosition();

	//if (!isCollision(entityNode->getPosition(), direction)) 
	//{

    // checkBounds(position);
				

//}
}

//update the stats
void Monster::updateRealStats()
{
}//end updateRealStats

void Monster::reset()
{
  entity->setQueryFlags(true);
  entity->setVisible(true);
  active = true;
  alive = true;
  entityNode->setPosition(0,-meshBox.getCorner(Ogre::AxisAlignedBox::FAR_LEFT_BOTTOM).y*scale,-400); // set position of player node.
}


Monster::Monster(MonsterTypes type, int requestedLevel)
{
	/*if(type == SNOTTLING)
	{
		name = ConfigLoader.getInstance().getValueAsString("MonsterSnottling/NAME");
		startingLevel = ConfigLoader.getInstance().getValueAsInt("MonsterSnottling/STARTINGLEVEL");
		startingHealth = ConfigLoader.getIgit nstance().getValueAsInt("MonsterSnottling/STARTINGHEALTH");
		startingAttack = ConfigLoader.getInstance().getValueAsInt("MonsterSnottling/STARTINGATTACK");
		startingDefence = ConfigLoader.getInstance().getValueAsInt("MonsterSnottling/STARTINGDEFENCE");
		startingDext = ConfigLoader.getInstance().getValueAsInt("MonsterSnottling/STARTINGDEXT");
		startingSpeed = ConfigLoader.getInstance().getValueAsInt("MonsterSnottling/STARTINGSPEED");

	}
	else if(type = BAT)
	{
		name = ConfigLoader.getInstance().getValueAsString("MonsterBat/NAME");
		startingLevel = ConfigLoader.getInstance().getValueAsInt("MonsterBat/STARTINGLEVEL");
		startingHealth = ConfigLoader.getInstance().getValueAsInt("MonsterBat/STARTINGHEALTH");
		startingAttack = ConfigLoader.getInstance().getValueAsInt("MonsterBat/STARTINGATTACK");
		startingDefence = ConfigLoader.getInstance().getValueAsInt("MonsterBat/STARTINGDEFENCE");
		startingDext = ConfigLoader.getInstance().getValueAsInt("MonsterBat/STARTINGDEXT");
		startingSpeed = ConfigLoader.getInstance().getValueAsInt("MonsterBat/STARTINGSPEED");
	}
	else if(type = WOLF)
	{
		name = ConfigLoader.getInstance().getValueAsString("MonsterWolf/NAME");
		startingLevel = ConfigLoader.getInstance().getValueAsInt("MonsterWolf/STARTINGLEVEL");
		startingHealth = ConfigLoader.getInstance().getValueAsInt("MonsterWolf/STARTINGHEALTH");
		startingAttack = ConfigLoader.getInstance().getValueAsInt("MonsterWolf/STARTINGATTACK");
		startingDefence = ConfigLoader.getInstance().getValueAsInt("MonsterWolf/STARTINGDEFENCE");
		startingDext = ConfigLoader.getInstance().getValueAsInt("MonsterWolf/STARTINGDEXT");
		startingSpeed = ConfigLoader.getInstance().getValueAsInt("MonsterWolf/STARTINGSPEED");
	}
	else
	{
		name = ConfigLoader.getInstance().getValueAsString("MonsterUnknown/NAME");
		startingLevel = ConfigLoader.getInstance().getValueAsInt("MonsterUnknown/STARTINGLEVEL");
		startingHealth = ConfigLoader.getInstance().getValueAsInt("MonsterUnknown/STARTINGHEALTH");
		startingAttack = ConfigLoader.getInstance().getValueAsInt("MonsterUnknown/STARTINGATTACK");
		startingDefence = ConfigLoader.getInstance().getValueAsInt("MonsterUnknown/STARTINGDEFENCE");
		startingDext = ConfigLoader.getInstance().getValueAsInt("MonsterUnknown/STARTINGDEXT");
		startingSpeed = ConfigLoader.getInstance().getValueAsInt("MonsterUnknown/STARTINGSPEED");
	}*/
	
	setupStandardBaseStats(requestedLevel);
		
}

//gets the type of monster
MonsterTypes Monster::getMonsterType()
{
	return monsterType;
}
//end getMonsterType