// Title       : RecurveBow.h
// Date        : 21/05/13
// Description : Class for the Recuve Bow, inherits from Weapon class

#include "Weapon.h"
#pragma once

class RecurveBow: public Weapon
{
private:

public:
  // CONSTRUCTORS AND DESTRUCTORS
  RecurveBow();

  ~RecurveBow();

  // GETTERS AND SETTERS
  void setPosition(Ogre::Vector3 thePosition); // Sets the position of the weapon

  void setActive(bool value); // Sets the weapons as active / inactive

  // CREATE AND RESET
  void create(Ogre::SceneManager* sentSceneMgr, Ogre::String theName);
  void reset();
};