#include "Skill.h"
#pragma once


class SkillPool
{
private:
	Skill* equippedSkills[8];
	bool activeSkillSlot1;
	bool activeSkillSlot2;
	bool activeSkillSlot3;
	bool activeSkillSlot4;
	bool activeSkillSlot5;
	bool activeSkillSlot6;
	bool activeSkillSlot7;
	bool activeSkillSlot8;

	Skill* unequippedSkills[50];

public:
	SkillPool();//constructor


	// subprogram used to assign a skill to a slot.
	// returns true if slot is assigned successfully else return false.
	bool insertSkill(int slotNumber, Skill*);

	//gets a specific skill from a specific skill slot
	Skill* getSkill(int slotNumber);

	//gets skill from an active skill slot (i.e being used)
	bool SkillPool::getActiveSkillSlot(int slotNumber)
	{
		switch(slotNumber)
		{
		case 1:
			return activeSkillSlot1;
		case 2:
			return activeSkillSlot2;
		case 3:
			return activeSkillSlot3;
		case 4:
			return activeSkillSlot4;
		case 5:
			return activeSkillSlot5;
		case 6:
			return activeSkillSlot6;
		case 7:
			return activeSkillSlot7;
		case 8:
			return activeSkillSlot8;
		}
		return false;
	}//end getActiveSkillSlot
};